<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/SampleApp/include/SampleApp/PortAudioMicrophoneWrapper.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_69fa8d0f4fee2820ffc8601fbf428b42.html">SampleApp</a></li><li class="navelem"><a class="el" href="dir_db613c36c14f3946188c6043fb421073.html">include</a></li><li class="navelem"><a class="el" href="dir_830f5381c57e8a6474fdf7a7193759cc.html">SampleApp</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">PortAudioMicrophoneWrapper.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_port_audio_microphone_wrapper_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_SAMPLEAPP_INCLUDE_SAMPLEAPP_PORTAUDIOMICROPHONEWRAPPER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_SAMPLEAPP_INCLUDE_SAMPLEAPP_PORTAUDIOMICROPHONEWRAPPER_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_audio_input_stream_8h.html">AVSCommon/AVS/AudioInputStream.h</a>&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;portaudio.h&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_microphone_interface_8h.html">Audio/MicrophoneInterface.h</a>&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">namespace </span>sampleApp {</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper.html">   31</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper.html">PortAudioMicrophoneWrapper</a> : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1application_utilities_1_1resources_1_1audio_1_1_microphone_interface.html">applicationUtilities::resources::audio::MicrophoneInterface</a> {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keyword">static</span> std::unique_ptr&lt;PortAudioMicrophoneWrapper&gt; <a class="code" href="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper.html#a122c36a64ce21bed977a6744d8255cd0">create</a>(std::shared_ptr&lt;avsCommon::avs::AudioInputStream&gt; stream);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper.html#a1fada96bfb468387d9965a0708dd164f">stopStreamingMicrophoneData</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper.html#ae6ec9587bf75c6fddf716363c9ee2462">startStreamingMicrophoneData</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper.html#a65103db2134eefa3e6ec21bb82fa9b6e">~PortAudioMicrophoneWrapper</a>();</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper.html">PortAudioMicrophoneWrapper</a>(std::shared_ptr&lt;avsCommon::avs::AudioInputStream&gt; stream);</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">int</span> PortAudioCallback(</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">void</span>* inputBuffer,</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="keywordtype">void</span>* outputBuffer,</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> numSamples,</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="keyword">const</span> PaStreamCallbackTimeInfo* timeInfo,</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        PaStreamCallbackFlags statusFlags,</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        <span class="keywordtype">void</span>* userData);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordtype">bool</span> initialize();</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keywordtype">bool</span> getConfigSuggestedLatency(PaTime&amp; suggestedLatency);</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keyword">const</span> std::shared_ptr&lt;avsCommon::avs::AudioInputStream&gt; m_audioInputStream;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    std::shared_ptr&lt;avsCommon::avs::AudioInputStream::Writer&gt; m_writer;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    PaStream* m_paStream;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    std::mutex m_mutex;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;};</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;}  <span class="comment">// namespace sampleApp</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_SAMPLEAPP_INCLUDE_SAMPLEAPP_PORTAUDIOMICROPHONEWRAPPER_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper_html_ae6ec9587bf75c6fddf716363c9ee2462"><div class="ttname"><a href="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper.html#ae6ec9587bf75c6fddf716363c9ee2462">alexaClientSDK::sampleApp::PortAudioMicrophoneWrapper::startStreamingMicrophoneData</a></div><div class="ttdeci">bool startStreamingMicrophoneData() override</div><div class="ttdef"><b>Definition:</b> PortAudioMicrophoneWrapper.cpp:131</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper_html_a122c36a64ce21bed977a6744d8255cd0"><div class="ttname"><a href="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper.html#a122c36a64ce21bed977a6744d8255cd0">alexaClientSDK::sampleApp::PortAudioMicrophoneWrapper::create</a></div><div class="ttdeci">static std::unique_ptr&lt; PortAudioMicrophoneWrapper &gt; create(std::shared_ptr&lt; avsCommon::avs::AudioInputStream &gt; stream)</div><div class="ttdef"><b>Definition:</b> PortAudioMicrophoneWrapper.cpp:50</div></div>
<div class="ttc" id="_audio_input_stream_8h_html"><div class="ttname"><a href="_audio_input_stream_8h.html">AudioInputStream.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper_html_a1fada96bfb468387d9965a0708dd164f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper.html#a1fada96bfb468387d9965a0708dd164f">alexaClientSDK::sampleApp::PortAudioMicrophoneWrapper::stopStreamingMicrophoneData</a></div><div class="ttdeci">bool stopStreamingMicrophoneData() override</div><div class="ttdef"><b>Definition:</b> PortAudioMicrophoneWrapper.cpp:141</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper_html_a65103db2134eefa3e6ec21bb82fa9b6e"><div class="ttname"><a href="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper.html#a65103db2134eefa3e6ec21bb82fa9b6e">alexaClientSDK::sampleApp::PortAudioMicrophoneWrapper::~PortAudioMicrophoneWrapper</a></div><div class="ttdeci">~PortAudioMicrophoneWrapper()</div><div class="ttdef"><b>Definition:</b> PortAudioMicrophoneWrapper.cpp:69</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1sample_app_1_1_port_audio_microphone_wrapper.html">alexaClientSDK::sampleApp::PortAudioMicrophoneWrapper</a></div><div class="ttdoc">This acts as a wrapper around PortAudio, a cross-platform open-source audio I/O library. </div><div class="ttdef"><b>Definition:</b> PortAudioMicrophoneWrapper.h:31</div></div>
<div class="ttc" id="_microphone_interface_8h_html"><div class="ttname"><a href="_microphone_interface_8h.html">MicrophoneInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1application_utilities_1_1resources_1_1audio_1_1_microphone_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1application_utilities_1_1resources_1_1audio_1_1_microphone_interface.html">alexaClientSDK::applicationUtilities::resources::audio::MicrophoneInterface</a></div><div class="ttdoc">This acts as an interface to record audio input from a microphone. </div><div class="ttdef"><b>Definition:</b> MicrophoneInterface.h:28</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
